<template lang="html">
  <div class="butter-options">
    <div class="options" v-show="showOptions">
      <p v-for="option in options" @click="change(option)">{{ option.label }}</p>
    </div>
    <butter-button theme="filter" size="ui" :active="showOptions" @click="$emit('click', value)">
      <slot></slot>
      <div class="select" @click="toggleOptions">
        <butter-icon name="triangle-down" width="8" height="5" />
      </div>
    </butter-button>
  </div>
</template>

<script>
export default {
  props: {
    options: {
      default() {
        return []
      },
      type: Array
    },
    value: {
      default: '',
      type: String
    },
  },
  data() {
    return {
      showOptions: false
    }
  },
  methods: {
    toggleOptions() {
      this.showOptions = !this.showOptions
    },
    change({ value }) {
      this.$emit('change', value)
      this.toggleOptions()
    }
  },
}
</script>

<style lang="scss" scoped>
@import 'butter-themes';
@import 'butter-mixins';
.butter-options {
  position: relative;
}
.select {
  cursor: pointer;
}
.options {
  @include themify($themes) {
    background-color: themed('color-select-primary');
    color: themed('color-text-primary');
  }
  @include corners($grid, $grid, $grid, $grid);
  position: absolute;
  right: 0;
  bottom: 100%;
  padding: 0;
  text-align: left;

  p {
    padding: $grid/2 $grid*2;

    &:hover {
      @include themify($themes) {
        background-color: themed('color-button-primary');
        color: themed('color-select-primary');
      }
      cursor: pointer;
    }
  }
}
</style>
